SystemOrganization addCategory: #protoGrowlComet!

WAComponent subclass: #PGServerTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'protoGrowlComet'!

PGServerTime class
	instanceVariableNames: 'process pusher mutex'!

PGServerTime class
	instanceVariableNames: 'process pusher mutex'!

!PGServerTime class methodsFor: 'testing' stamp: 'pmm 10/14/2006 12:31'!
canBeRoot
	^true! !

!PGServerTime class methodsFor: 'accessing' stamp: 'pmm 10/14/2006 12:31'!
description
	^'protoGrowl Comet Demo'! !

!PGServerTime class methodsFor: 'process' stamp: 'pmm 10/13/2006 23:16'!
ensureProcessRunning
	mutex critical: [
		process isNil ifTrue: [
			process := [ [
				| seconds |
				seconds := (2 to: 10) atRandom.
				(Delay forSeconds: seconds) wait.
				self sendTime: seconds ] repeat
			]
				forkAt: Processor userBackgroundPriority
				named: 'protoGrowl time server' ] ]! !

!PGServerTime class methodsFor: 'class initialization' stamp: 'pmm 10/13/2006 23:12'!
initialize
	"self initialize"
	| application |
	pusher := CTPusher new.
	application := self registerAsApplication: 'comet/growl'.
	application preferenceAt: #sessionClass put: CTSession.	
	application libraries
		add: SULibrary;
		add: CTLibrary;
		add: PGScripts;
		add: PGStyles.
	mutex := Semaphore forMutualExclusion.
	Smalltalk addToShutDownList: self! !

!PGServerTime class methodsFor: 'accessing' stamp: 'pmm 10/13/2006 22:44'!
pusher
	^pusher! !

!PGServerTime class methodsFor: 'accessing' stamp: 'pmm 10/15/2006 18:11'!
sendTime: anInteger
	pusher javascript: (PGGrowlFactory new beInfo
		title: 'Server Time';
		renderMessage: [ :r |
			r text: DateAndTime now displayString.
			r break.
			r text: 'Delay was: '.
			r strong: anInteger printString, ' seconds' ];
		yourself)! !

!PGServerTime class methodsFor: 'process' stamp: 'pmm 10/13/2006 23:06'!
shutDown
	mutex critical: [		
		process ifNil: [ ^ self ].
		process terminate.
		process := nil ]! !

!PGServerTime methodsFor: 'initialize-release' stamp: 'pmm 10/13/2006 23:08'!
initialize
	super initialize.
	self class ensureProcessRunning! !

!PGServerTime methodsFor: 'accessing' stamp: 'pmm 10/13/2006 22:50'!
pusher
	^ self class pusher! !

!PGServerTime methodsFor: 'rendering' stamp: 'pmm 10/14/2006 12:47'!
renderContentOn: html
	html heading level1; with: 'protoGrowl Comet Demo'.
	html paragraph: 'Messages will show up at the bottom at random intervals between 2 and 10 seconds.'.
	html script: (html comet
		pusher: self pusher;
		connect)! !

!PGServerTime methodsFor: 'rendering' stamp: 'pmm 10/13/2006 23:08'!
rendererClass
	^ WARenderCanvas! !

!PGServerTime methodsFor: 'path' stamp: 'pmm 10/15/2006 19:23'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot title: 'protoGrowl Comet Demo'! !
PGServerTime initialize!
